;------------------------------------------------------------------------------
;---	Keyboard + Joy query for "good" and "bad" keyb. latch TED
;---	2021.06.06.+, BSZ
;------------------------------------------------------------------------------
	CPU	6502
	PAGE	0,0

rasterirq_pos	=	$0d0

kernal_monitor	=	$ff52
kernal_keybscan	=	$db11
kernal_irqend	=	$fcbe

saved_joyskeys	=	$0c00

start_addr	=	$1100

;------------------------------------------------------------------------------
	ORG	start_addr - 2
	ADR	start_addr
;------------------------------------------------------------------------------
;---	Inicialize:
		sei
		lda	#interrupt & $ff
		sta	$0314
		lda	#interrupt >> 8
		sta	$0315
		lda	#rasterirq_pos & $ff
		sta	$ff0b
		lda	#(rasterirq_pos >> 8)|%00000010		;Raster IRQ pos B8 + Rast IRQ Enable
		sta	$ff0a
		lda	#%11111111
		sta	$ff09					;Clear pending interrupts
		cli
		jmp	kernal_monitor
;------------------------------------------------------------------------------
;---	Interrupt routine:
interrupt	inc	$ff19
		jsr	joykeyb_query
		dec	$ff19
		lda	#%11111111
		sta	$ff09					;Clear pending interrupts
		;jsr	kernal_keybscan				;KERNAL Keyboard scan
		jmp	kernal_irqend				;Interrupt end
;------------------------------------------------------------------------------
;---	Joy and keyboard query:
joykeyb_query	lda	#%11111111
		sta	$fd30					;Disable all Keyboard lines

		lda	$ff13
		pha
		ora	#%00000010				;Single Clock mode selected
		sta	$ff13
		sta	$ff3f					;RAM selected
		lda	$ffff
		pha

		ldx	#%11111011				;Joy Lo
		ldy	#%11111101				;Joy Hi
		lda	$ff1d
.waitnewline1	cmp	$ff1d
		beq	.waitnewline1
		stx	$ffff					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+0			;4
		sty	$ffff					;4
		sty	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+1			;4 All: 32 single clock cycles

		lda	#%00000000				;Double Clock mode selected
		sta	$ff13

		ldx	#%11111111				;No Joy line selected
		lda	$ff1d
.waitnewline2	cmp	$ff1d
		beq	.waitnewline2
		lda	#%01111111				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+40			;4
		lda	#%10111111				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+41			;4
		lda	#%11011111				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+42			;4
		lda	#%11101111				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+43			;4 All: 72 double clock cycles

		lda	$ff1d
.waitnewline3	cmp	$ff1d
		beq	.waitnewline3
		lda	#%11110111				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+44			;4
		lda	#%11111011				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+45			;4
		lda	#%11111101				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+46			;4
		lda	#%11111110				;2
		sta	$fd30					;4
		stx	$ff08					;4
		lda	$ff08					;4
		sta	saved_joyskeys+47			;4 All: 72 double clock cycles

		pla
		sta	$ffff					;IRQ vector restore
		pla
		sta	$ff13					;Chargen. address + speed restore
		and	#%00000001
		beq	.ramsel
		sta	$ff3e					;ROM/RAM restore
.ramsel		rts
;------------------------------------------------------------------------------
